/**
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.dotty;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see fr.irisa.cairn.graphviz.model.dotty.DottyPackage
 * @generated
 */
public interface DottyFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  DottyFactory eINSTANCE = fr.irisa.cairn.graphviz.model.dotty.impl.DottyFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Graph</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Graph</em>'.
   * @generated
   */
  Graph createGraph();

  /**
   * Returns a new object of class '<em>Compound</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Compound</em>'.
   * @generated
   */
  Compound createCompound();

  /**
   * Returns a new object of class '<em>Node</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Node</em>'.
   * @generated
   */
  Node createNode();

  /**
   * Returns a new object of class '<em>Leaf Node</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Leaf Node</em>'.
   * @generated
   */
  LeafNode createLeafNode();

  /**
   * Returns a new object of class '<em>Sub Node</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Sub Node</em>'.
   * @generated
   */
  SubNode createSubNode();

  /**
   * Returns a new object of class '<em>Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Attribute</em>'.
   * @generated
   */
  Attribute createAttribute();

  /**
   * Returns a new object of class '<em>Shape Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Shape Attribute</em>'.
   * @generated
   */
  ShapeAttribute createShapeAttribute();

  /**
   * Returns a new object of class '<em>Compound Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Compound Attribute</em>'.
   * @generated
   */
  CompoundAttribute createCompoundAttribute();

  /**
   * Returns a new object of class '<em>Color Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Color Attribute</em>'.
   * @generated
   */
  ColorAttribute createColorAttribute();

  /**
   * Returns a new object of class '<em>Style Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Style Attribute</em>'.
   * @generated
   */
  StyleAttribute createStyleAttribute();

  /**
   * Returns a new object of class '<em>Label Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Label Attribute</em>'.
   * @generated
   */
  LabelAttribute createLabelAttribute();

  /**
   * Returns a new object of class '<em>Rank Attribute</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Rank Attribute</em>'.
   * @generated
   */
  RankAttribute createRankAttribute();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  DottyPackage getDottyPackage();

} //DottyFactory
